| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | |
| 3 | ## |
| 4 | # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U. |
| 5 | # This file is part of openmano |
| 6 | # All Rights Reserved. |
| 7 | # |
| 8 | # Licensed under the Apache License, Version 2.0 (the "License"); you may |
| 9 | # not use this file except in compliance with the License. You may obtain |
| 10 | # a copy of the License at |
| 11 | # |
| 12 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 13 | # |
| 14 | # Unless required by applicable law or agreed to in writing, software |
| 15 | # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT |
| 16 | # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the |
| 17 | # License for the specific language governing permissions and limitations |
| 18 | # under the License. |
| 19 | # |
| 20 | # For those usages not covered by the Apache License, Version 2.0 please |
| 21 | # contact with: nfvlabs@tid.es |
| 22 | ## |
| 23 | |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 24 | #ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 25 | #Get needed packages, source code and configure to run openmano |
| 26 | #Ask for database user and password if not provided |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 27 | |
| 28 | function usage(){ |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 29 | echo -e "usage: sudo $0 [OPTIONS]" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 30 | echo -e "Install last stable source code in ./openmano and the needed packages" |
| 31 | echo -e "On a Ubuntu 16.04 it configures openmano as a service" |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 32 | echo -e " OPTIONS" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 33 | echo -e " -u USER: database admin user. 'root' by default. Prompts if needed" |
| 34 | echo -e " -p PASS: database admin password to be used or installed. Prompts if needed" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 35 | echo -e " -q --quiet: install in unattended mode" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 36 | echo -e " -h --help: show this help" |
| 37 | echo -e " --develop: install last version for developers, and do not configure as a service" |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 38 | echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one" |
| 39 | echo -e " --force: makes idenpotent, delete previous installations folders if needed" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 40 | echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo" |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 41 | echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation" |
| garciadeblas | 5b1a664 | 2017-04-18 10:10:31 +0200 | [diff] [blame] | 42 | echo -e " --no-db: do not install mysql server" |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 43 | } |
| 44 | |
| 45 | function install_packages(){ |
| 46 | [ -x /usr/bin/apt-get ] && apt-get install -y $* |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 47 | [ -x /usr/bin/yum ] && yum install -y $* |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 48 | |
| 49 | #check properly installed |
| 50 | for PACKAGE in $* |
| 51 | do |
| 52 | PACKAGE_INSTALLED="no" |
| 53 | [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes" |
| 54 | [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes" |
| 55 | if [ "$PACKAGE_INSTALLED" = "no" ] |
| 56 | then |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 57 | echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2 |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 58 | exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 59 | fi |
| 60 | done |
| 61 | } |
| 62 | |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 63 | GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 64 | GIT_OVIM_URL=https://osm.etsi.org/gerrit/osm/openvim.git |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 65 | DBUSER="root" |
| 66 | DBPASSWD="" |
| 67 | DBPASSWD_PARAM="" |
| 68 | QUIET_MODE="" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 69 | DEVELOP="" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 70 | FORCEDB="" |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 71 | FORCE="" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 72 | NOCLONE="" |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 73 | NO_PACKAGES="" |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 74 | NO_DB="" |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 75 | while getopts ":u:p:hiq-:" o; do |
| 76 | case "${o}" in |
| 77 | u) |
| 78 | export DBUSER="$OPTARG" |
| 79 | ;; |
| 80 | p) |
| 81 | export DBPASSWD="$OPTARG" |
| 82 | export DBPASSWD_PARAM="-p$OPTARG" |
| 83 | ;; |
| 84 | q) |
| 85 | export QUIET_MODE=yes |
| 86 | export DEBIAN_FRONTEND=noninteractive |
| 87 | ;; |
| 88 | h) |
| 89 | usage && exit 0 |
| 90 | ;; |
| 91 | -) |
| 92 | [ "${OPTARG}" == "help" ] && usage && exit 0 |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 93 | [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 94 | [ "${OPTARG}" == "forcedb" ] && FORCEDB="y" && continue |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 95 | [ "${OPTARG}" == "force" ] && FORCEDB="y" && FORCE="y" && continue |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 96 | [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 97 | [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 98 | [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 99 | [ "${OPTARG}" == "no-db" ] && NO_DB="y" && continue |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 100 | echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2 |
| 101 | exit 1 |
| 102 | ;; |
| 103 | \?) |
| 104 | echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2 |
| 105 | exit 1 |
| 106 | ;; |
| 107 | :) |
| 108 | echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2 |
| 109 | exit 1 |
| 110 | ;; |
| 111 | *) |
| 112 | usage >&2 |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 113 | exit 1 |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 114 | ;; |
| 115 | esac |
| 116 | done |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 117 | |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 118 | #check root privileges and non a root user behind |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 119 | [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1 |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 120 | if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]] |
| 121 | then |
| 122 | [[ -z $QUIET_MODE ]] && read -e -p "Install in the root user (y/N)?" KK |
| 123 | [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1 |
| 124 | export SUDO_USER=root |
| 125 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 126 | |
| 127 | #Discover Linux distribution |
| 128 | #try redhat type |
| 129 | [ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1) |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 130 | #else assuming ubuntu type |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 131 | [ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null) |
| 132 | if [ "$_DISTRO" == "Ubuntu" ] |
| 133 | then |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 134 | _RELEASE=$(lsb_release -rs) |
| 135 | if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]] |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 136 | then |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 137 | [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)'? (y/N)" KK |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 138 | [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1 |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 139 | _RELEASE = 14 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 140 | fi |
| 141 | elif [ "$_DISTRO" == "CentOS" ] |
| 142 | then |
| 143 | _RELEASE="7" |
| 144 | if ! cat /etc/redhat-release | grep -q "7." |
| 145 | then |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 146 | [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested CentOS version. Continue assuming a '_RELEASE' type? (y/N)" KK |
| 147 | [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 148 | fi |
| 149 | elif [ "$_DISTRO" == "Red" ] |
| 150 | then |
| 151 | _RELEASE="7" |
| 152 | if ! cat /etc/redhat-release | grep -q "7." |
| 153 | then |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 154 | [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Red Hat OS version. Continue assuming a '_RELEASE' type? (y/N)" KK |
| 155 | [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 156 | fi |
| 157 | else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ] |
| 158 | _DISTRO_DISCOVER=$_DISTRO |
| 159 | [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14" |
| 160 | [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7" |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 161 | [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type? (y/N)" KK |
| 162 | [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 163 | fi |
| 164 | |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 165 | #check if installed as a service |
| 166 | INSTALL_AS_A_SERVICE="" |
| 167 | [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y" |
| 168 | #Next operations require knowing OPENMANO_BASEFOLDER |
| 169 | if [[ -z "$NOCLONE" ]]; then |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 170 | if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then |
| 171 | OPENMANO_BASEFOLDER=__openmano__${RANDOM} |
| 172 | else |
| 173 | OPENMANO_BASEFOLDER="${PWD}/openmano" |
| 174 | fi |
| 175 | [[ -n "$FORCE" ]] && rm -rf $OPENMANO_BASEFOLDER #make idempotent |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 176 | else |
| 177 | HERE=$(realpath $(dirname $0)) |
| 178 | OPENMANO_BASEFOLDER=$(dirname $HERE) |
| 179 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 180 | |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 181 | if [[ -z "$NO_PACKAGES" ]] #if (UPDATE REPOS) |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 182 | then |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 183 | echo ' |
| 184 | ################################################################# |
| 185 | ##### UPDATE REPOSITORIES ##### |
| 186 | #################################################################' |
| 187 | [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y |
| 188 | |
| 189 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y |
| 190 | [ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release |
| 191 | [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \ |
| 192 | && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm |
| 193 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist |
| 194 | |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 195 | fi #if (UPDATE REPOS) |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 196 | |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 197 | if [[ -z "$NO_PACKAGES" ]] #if (INSTALL DEPENDENCIES) |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 198 | then |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 199 | echo ' |
| 200 | ################################################################# |
| 201 | ##### INSTALL REQUIRED PACKAGES ##### |
| 202 | #################################################################' |
| tierno | 05a8b7b | 2017-04-20 18:56:07 +0200 | [diff] [blame] | 203 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "git make screen wget mysql-client" |
| 204 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git make screen wget mariadb-client" |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 205 | fi #if (INSTALL DEPENDENCIES) |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 206 | |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 207 | if [[ -z "$NO_PACKAGES" ]] #if (PYTHON PACKAGES AND PIP PACKAGES) |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 208 | then |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 209 | echo ' |
| 210 | ################################################################# |
| 211 | ##### INSTALL PYTHON PACKAGES ##### |
| 212 | #################################################################' |
| bayramov | fe3f3c9 | 2016-10-04 07:53:41 +0400 | [diff] [blame] | 213 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip" |
| 214 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip" |
| tierno | f70d096 | 2017-01-30 12:39:09 +0100 | [diff] [blame] | 215 | #The only way to install python-bottle on Centos7 is with easy_install or pip |
| 216 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle |
| bayramov | fe3f3c9 | 2016-10-04 07:53:41 +0400 | [diff] [blame] | 217 | |
| 218 | #required for vmware connector TODO move that to separete opt in install script |
| 219 | sudo pip install --upgrade pip |
| 220 | sudo pip install pyvcloud |
| 221 | sudo pip install progressbar |
| 222 | sudo pip install prettytable |
| bhangare | fda5f7c | 2017-01-12 23:50:34 -0800 | [diff] [blame] | 223 | sudo pip install pyvmomi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 224 | |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 225 | #required for AWS connector |
| tierno | f70d096 | 2017-01-30 12:39:09 +0100 | [diff] [blame] | 226 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-boto" |
| 227 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-boto" #TODO check if at Centos it exist with this name, or PIP should be used |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 228 | |
| 229 | #install openstack client needed for using openstack as a VIM |
| tierno | 93bffb4 | 2016-12-31 17:08:51 +0100 | [diff] [blame] | 230 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient" |
| 231 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient #TODO revise if gcc python-pip is needed |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 232 | fi #if (PYTHON PACKAGES AND PIP PACKAGES) |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 233 | |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 234 | if [[ -z $NOCLONE ]]; then |
| 235 | echo ' |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 236 | ################################################################# |
| 237 | ##### DOWNLOAD SOURCE ##### |
| 238 | #################################################################' |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 239 | su $SUDO_USER -c "git clone ${GIT_URL} ${OPENMANO_BASEFOLDER}" |
| 240 | su $SUDO_USER -c "cp ${OPENMANO_BASEFOLDER}/.gitignore-common ${OPENMANO_BASEFOLDER}/.gitignore" |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 241 | [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER} checkout tags/v1.1.0" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 242 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 243 | |
| 244 | echo ' |
| 245 | ################################################################# |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 246 | ##### INSTALLING OVIM LIBRARY ##### |
| 247 | #################################################################' |
| 248 | su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER} clone ${GIT_OVIM_URL} openvim" |
| 249 | [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER}/openvim checkout master" |
| 250 | # Install debian dependencies before setup.py |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 251 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "libmysqlclient-dev" |
| 252 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "libmysqlclient-dev" #TODO check if that's the name in CentOS and RedHat |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 253 | make -C ${OPENMANO_BASEFOLDER}/openvim lite |
| garciadeblas | d5b5dcc | 2017-04-21 13:05:56 +0200 | [diff] [blame^] | 254 | OSMLIBOVIM_PATH=`python -c 'import lib_osm_openvim; print lib_osm_openvim.__path__[0]'` |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 255 | |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 256 | if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] |
| 257 | then |
| 258 | echo ' |
| 259 | ################################################################# |
| 260 | ##### CONFIGURE firewalld ##### |
| 261 | #################################################################' |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 262 | KK=yes |
| 263 | [[ -z $QUIET_MODE ]] && read -e -p "Configure firewalld for openmanod port 9090? (Y/n)" KK |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 264 | if [ "$KK" != "n" -a "$KK" != "no" ] |
| 265 | then |
| 266 | #Creates a service file for openmano |
| 267 | echo '<?xml version="1.0" encoding="utf-8"?> |
| 268 | <service> |
| 269 | <short>openmanod</short> |
| 270 | <description>openmanod service</description> |
| 271 | <port protocol="tcp" port="9090"/> |
| 272 | </service>' > /etc/firewalld/services/openmanod.xml |
| 273 | #put proper permissions |
| 274 | pushd /etc/firewalld/services > /dev/null |
| 275 | restorecon openmanod.xml |
| 276 | chmod 640 openmanod.xml |
| 277 | popd > /dev/null |
| 278 | #Add the openmanod service to the default zone permanently and reload the firewall configuration |
| 279 | firewall-cmd --permanent --add-service=openmanod > /dev/null |
| 280 | firewall-cmd --reload > /dev/null |
| 281 | echo "done." |
| 282 | else |
| 283 | echo "skipping." |
| 284 | fi |
| 285 | fi |
| 286 | |
| 287 | echo ' |
| 288 | ################################################################# |
| 289 | ##### CONFIGURE OPENMANO CLIENT ##### |
| 290 | #################################################################' |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 291 | #creates a link at ~/bin if not configured as a service |
| 292 | if [[ -z "$INSTALL_AS_A_SERVICE" ]] |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 293 | then |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 294 | su $SUDO_USER -c 'mkdir -p ${HOME}/bin' |
| 295 | su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano' |
| 296 | su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report' |
| 297 | su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano' |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 298 | su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/openmano' "'${HOME}/bin/openmano' |
| 299 | su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report' |
| 300 | su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh' "'${HOME}/bin/service-openmano' |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 301 | |
| 302 | #insert /home/<user>/bin in the PATH |
| 303 | #skiped because normally this is done authomatically when ~/bin exist |
| 304 | #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin" |
| 305 | #then |
| 306 | # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc" |
| 307 | # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc' |
| 308 | #fi |
| 309 | if [[ $SUDO_USER == root ]] |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 310 | then |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 311 | if ! echo $PATH | grep -q "${HOME}/bin" |
| 312 | then |
| 313 | echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc |
| 314 | fi |
| 315 | fi |
| 316 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 317 | |
| 318 | #configure arg-autocomplete for this user |
| 319 | #in case of minimal instalation this package is not installed by default |
| 320 | [[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion |
| 321 | #su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d' |
| 322 | su $SUDO_USER -c 'activate-global-python-argcomplete --user' |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 323 | if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc' |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 324 | then |
| 325 | echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc" |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 326 | su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc' |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 327 | fi |
| 328 | |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 329 | if [ -z "$NO_DB" ]; then |
| 330 | echo ' |
| 331 | ################################################################# |
| 332 | ##### INSTALL DATABASE SERVER ##### |
| 333 | #################################################################' |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 334 | |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 335 | if [ -n "$QUIET_MODE" ]; then |
| 336 | DB_QUIET='-q' |
| 337 | fi |
| 338 | if [ -n "$FORCEDB" ]; then |
| 339 | DB_FORCE='--forcedb' |
| 340 | fi |
| tierno | 05a8b7b | 2017-04-20 18:56:07 +0200 | [diff] [blame] | 341 | ${OPENMANO_BASEFOLDER}/database_utils/install-db-server.sh -u $DBUSER $DBPASSWD_PARAM $DB_QUIET $DB_FORCE || exit 1 |
| 342 | echo ' |
| 343 | ################################################################# |
| 344 | ##### CREATE AND INIT MANO_VIM DATABASE ##### |
| 345 | #################################################################' |
| 346 | # Install mano_vim_db after setup |
| garciadeblas | c7fc0f9 | 2017-04-21 12:50:51 +0200 | [diff] [blame] | 347 | ${OSMLIBOVIM_PATH}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} -u mano -p manopw -d mano_vim_db || exit 1 |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 348 | |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 349 | fi |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 350 | |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 351 | if [[ -n "$INSTALL_AS_A_SERVICE" ]] |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 352 | then |
| 353 | echo ' |
| 354 | ################################################################# |
| 355 | ##### CONFIGURE OPENMANO SERVICE ##### |
| 356 | #################################################################' |
| 357 | |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 358 | ${OPENMANO_BASEFOLDER}/scripts/install-openmano-service.sh -f ${OPENMANO_BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"` |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 359 | # rm -rf ${OPENMANO_BASEFOLDER} |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 360 | # alias service-openmano="service openmano" |
| 361 | # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc |
| 362 | |
| 363 | echo |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 364 | echo "Done! installed at /opt/openmano" |
| 365 | echo " Manage server with 'sudo service openmano start|stop|status|...' " |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 366 | |
| 367 | |
| 368 | else |
| 369 | |
| 370 | echo |
| 371 | echo "Done! you may need to logout and login again for loading client configuration" |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 372 | echo " Run './${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh start' for starting openmano in a screen" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 373 | |
| 374 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 375 | |